/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           SymTab.h
*      created          7/14/1996
*      updated          8/14/1996
*      works            xx
*
*      function         SymTab
*
*
*
*************************************************************/
#ifndef _SYMTAB_H
#define _SYMTAB_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#if __STDC__ == 1
/*
 * The following macro definations take affect when compiling under ansi C
 *
 * The A_ macro is provided for function prototype declarations.  It allows
 * ANSI C prototypes to be complied under K&R C
 */

#define A_(x) x

#else
/* The following macro definations take affect when compiling under K&R C */

#define const
#define volatile
#define A_(x) ()

#endif  /* __STDC__ */

#include "List.h"
 
typedef Np STEP;


struct SYMTAB
{
	STEP L;
};

/*prototypes*/

extern void
SymTabInit A_((void));

extern void
SymTabKeyWordsInit A_((void));

extern void
SymTabPutDF A_((int df));

extern void
SymTabCondPrint A_((char *str));

extern int
SymTabIsEmpty A_((void));

extern void
SymTabPrint A_((void));

extern void
SymTabErr A_((int e));

extern void
SymTabInsertFront A_((STEP nxp));

extern void
SymTabInsertSortedN A_((STEP nxp));

extern void
symTabInsertSortedD A_((char * lexem, int typ, int lineDe, int leve, int funFla));

extern int
SymTabIsMember A_((STEP nxp));

extern STEP
SymTabGetLast A_((void));

extern STEP
SymTabGetSucc A_((STEP nxp));

extern void
SymTabDelete A_((void));

extern void
SymTabDeleteNode A_((STEP nxp));

extern STEP
SymTabFindNodeByLexemeInProg A_((char * lexem));

extern STEP
SymTabFindNodeByLexemeInLevel A_((char * lexem, int leve));

extern STEP
SymTabFindNodeByLexemeAndTypeInLevel A_((char * lexem, int leve, int type, int (*compare_func)()));

extern STEP
SymTabFindAnyNodeInLevelOfType A_((int leve, int type));

extern void
SymTabDeleteLevel A_((int leve));

extern STEP
SymTabGetOrigin A_((void));

extern void
SymTabParamLink A_((STEP funNp, Np parNp));

extern STEP
SymTabFindFunProtoByLexemeInProg A_((char * lexem));
#endif /* _SYMTAB_H */
